<?php

// $id:$

include("ServerScriptHelper.php");

$serverScriptHelper = new ServerScriptHelper();

$cce = $serverScriptHelper->getCceClient();

$factory = $serverScriptHelper->getHtmlComponentFactory("base-portforward", "detailHandler.php?OID=$OID");
$page = $factory->getPage();
$i18n = $factory->getI18n("base-portforward");

// Check to see if we are deleting this rule..
if ($OID && $todo == "remove") {
	$cce->destroy($OID);
	print $serverScriptHelper->toHandlerHtml("/base/portforward/list.php", $cce->errors());
	exit;
}

// Get the values to plug in:
if ($OID) {
	$values = $cce->get($OID);
} else {
	$values = array();
}

if ($DATA) {
	$values = unserialize($DATA);
}

$block = $factory->getPagedBlock($OID ? "title_modify" : "title_create");

$block->addFormField(
	$factory->getMultiChoice("protocol", array("TCP", "UDP"), array( $values["protocol"] )),
	$factory->getLabel("protocol")
);

include_once("uifc/MultiChoice.php");
include_once("uifc/Option.php");
include_once("uifc/Label.php");
$dev = new MultiChoice($page, "sourceIP");
$networkOids = $cce->findSorted("Network","device");
foreach ($networkOids as $networkOid) {
	$network = $cce->get($networkOid);
	if (!$network["enabled"]) continue;
	$device = $network["device"];
	// munge together a msgid name
	$tag = "[[base-portforward.SourceIP_" . $device . "]]";
	$isSelected = ($network["device"] == $values["sourceIP"]);
	$dev->addOption(
	  new Option(
	    new Label(	$page,
			$i18n->interpolate(
				$tag, array( "ipaddr" => $network["ipaddr"] )
			)
	    ),
	    $device, 
	    $isSelected
	  )
	);
}

// list device/ip in a dropdown
$block->addFormField(
	$dev,
	//$factory->getIpAddress("sourceIP", $values["sourceIP"]),
	$factory->getLabel("sourceIP")
);
$block->addFormField(
	$factory->getInteger("sourcePort", $values["sourcePort"], 1, 65535),
	$factory->getLabel("sourcePort")
);
$block->addFormField(
	$factory->getIpAddress("targetIP", $values["targetIP"]),
	$factory->getLabel("targetIP")
);
$block->addFormField(
	$factory->getInteger("targetPort", $values["targetPort"], 1, 65535),
	$factory->getLabel("targetPort")
);

$description = $factory->getTextBlock("description", $values["description"]);
$description->setOptional(true);
$block->addFormField(
	$description,
	$factory->getLabel("description")
);

$block->addButton($factory->getSaveButton($page->getSubmitAction()));
$block->addButton($factory->getCancelButton("/base/portforward/list.php"));

print $page->toHeaderHtml();
print $block->toHtml();
print $page->toFooterHtml();

/*
function getIpAddr ($deviceName) {
	$retval = $factory->getLabel("noIpAddr");
	$oids = $cce->find("Network");
	for ($i = 0; $i < count($oids); $i++) {
		$oid = $oids[$i];
		$obj = $cce->get($oid);
		if ($obj["device"] == $deviceName) {
			$retval = $obj["ipaddr"];
		}
	}
	return $retval
}
*/
